#include <amxmodx>
#include <cstrike>
#include <chatcolor>

#define	PLUGIN	"Money Transferer"
#define	VERSION	"1.0"
#define	AUTHOR	"kalash1k"

new players_menu, players[32], num, i
new accessmenu, iName[64], callback

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_clcmd("say /tm", "transfer_menu", ADMIN_ALL, "")	// TM - transfer money
	register_clcmd("say /transfer", "transfer_menu", ADMIN_ALL, "")
	register_clcmd("say /money", "transfer_menu", ADMIN_ALL, "")
	register_clcmd("say_team /tm", "transfer_menu", ADMIN_ALL, "")
	register_clcmd("say_team /transfer", "transfer_menu", ADMIN_ALL, "")
	register_clcmd("say_team /money", "transfer_menu", ADMIN_ALL, "")

	
	register_clcmd("transfer", "transfer_money", ADMIN_ALL, "")
}

public transfer_menu(id)
{
	get_players(players, num, "h")
	
	if (num <= 1)
	{
		client_print_color(id, Red, "Некому передать деньги")
		return PLUGIN_HANDLED
	}
	
	new tempname[32], info[10]
	
	players_menu = menu_create("Игроки", "players_menu_handler")
	
	for(i = 0; i < num; i++)
	{
		if(players[i] == id)
			continue
		
		get_user_name(players[i], tempname, 31)
		num_to_str(players[i], info, 9)
		menu_additem(players_menu, tempname, info, 0)
	}
	
	menu_setprop(players_menu, MPROP_EXIT, MEXIT_ALL)
	
	menu_display(id, players_menu, 0)
	return PLUGIN_CONTINUE
}

public players_menu_handler(id, players_menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(players_menu)
		return PLUGIN_HANDLED
	}
	
	new data[6]
	
	menu_item_getinfo(players_menu, item, accessmenu, data, charsmax(data), iName, charsmax(iName), callback)
	
	new player = str_to_num(data)
	
	client_cmd(id, "messagemode ^"transfer %i^"", player)
	
	return PLUGIN_CONTINUE
}

public transfer_money(id)
{
	new param[5]
	read_argv(2, param, charsmax(param))
	
	for (new x; x < strlen(param); x++)
	{
		if(!isdigit(param[x]))
		{
			client_print_color(id, Red, "Параметр должен быть числом")
			return PLUGIN_HANDLED
		}
	}
	
	new amount = str_to_num(param)
	
	new money = cs_get_user_money(id)
	
	if (money < amount)
	{
		client_print_color(id, Red, "У вас не хватает денег")
		return PLUGIN_HANDLED
	}
	
	read_argv(1, param, charsmax(param))
	new player = str_to_num(param)
	
	new player_money = cs_get_user_money(player)
	
	cs_set_user_money(id, money - amount, 1)
	cs_set_user_money(player, player_money + amount, 1)
	
	new names[2][32]
	
	get_user_name(id, names[0], 31)
	get_user_name(player, names[1], 31)
	
	client_print_color(0, Blue, "^1Игрок ^3%s ^1передал ^4$%i ^3%s", names[0], amount, names[1])
	
	return PLUGIN_HANDLED
}
